from netgen.meshing import *
from netgen.meshing import Mesh as NetMesh
from ngsolve import *
from ngsolve import *

def AddEdgeEls (p1, dx, facenr, n, pids,mesh):
    for i in range(n):
        base = p1 + i*dx
        pnum = [base, base+dx]
        elpids = [pids[p] for p in pnum]
        mesh.Add (Element1D(elpids,index=i+1))
        if i < n/2:
            mesh.SetMaterial(i+1, 'mat1')
        else :
            mesh.SetMaterial(i+1, 'mat2')

def SegMesh(n,x0,x1,per):
    mesh = NetMesh(dim=1)
    pids = []
    for i in range(n+1):
        pids.append (mesh.Add (MeshPoint(Pnt(x0+(x1-x0)*i/n, 0, 0))))
    AddEdgeEls(0,1,1,n,pids,mesh)
    mesh.Add (Element0D( pids[0], index=1))
    mesh.Add (Element0D( pids[n], index=2))
    mesh.Add (Element0D( pids[int(n/2)], index=3))
    mesh.SetBCName(0, "left")
    mesh.SetBCName(1, "right")
    mesh.SetBCName(2, "interface")
    if per == 1:
        mesh.AddPointIdentification(pids[0],pids[n],1,2)
    return Mesh(mesh)

mesh = SegMesh(4, 0,1,False)
V = FacetFESpace(mesh, order=0)

u,v = V.TnT()
a = BilinearForm(V)
a += u.Trace()*v.Trace()*ds("interface")
a.Assemble()
print(a.mat)
